# Written For Python3+
# Written By: InformalAbsence
# Email: informalabsence@gmail.com

from Phidget22.Devices.DigitalOutput import *
from http.server import BaseHTTPRequestHandler
import socketserver

# Hub Port For Plug
PLUG_PORT = 0 

# Set Up Phidget Plug
plug = DigitalOutput()
# Assign Port
plug.setHubPort(PLUG_PORT)
plug.setIsHubPortDevice(True)
# Open
plug.openWaitForAttachment(1000)

# Create class of type BaseHTTPRequestHandler 
class WebHandler(BaseHTTPRequestHandler):

    # Create function that will "do" something apon a GET request
    def do_POST(self):
        # if request is to turn on the lights, turn them on
        if self.path == "/turnOn":
            # Turn On 
            plug.setState(True)
            # Send 200 OK response 
            self.send_response(200)
        # if request is to turn off the lights, turn them off
        elif self.path == "/turnOff":
            # Turn plug off
            plug.setState(False)
            # Send 200 OK response 
            self.send_response(200)
        else:
            # Unknown request, send 404 NOT FOUND
            self.send_response(404)

# Initalize socket for server listening on 0.0.0.0 port 8081
httpd = socketserver.TCPServer(("", 8081), WebHandler)
try:
    # Start Listening 
    httpd.serve_forever()

except Exception as err:
    # On Err, or KeyboardInterrupt, close server so that port is not tied up forever
    print(f"Err: {err}, Quitting!")
    httpd.server_close()
        

